---
title: <image>
slug: Web/CSS/image
tags:
  - CSS
  - CSS Data Type
  - CSS Images
  - Data Type
  - Graphics
  - Layout
  - Reference
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>&lt;image&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> represents a two-dimensional image.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>&lt;image&gt;</code> data type can be represented with any of the following:</p>

<ul>
	<li>An image denoted by the {{CSSxRef("&lt;url&gt;")}} data type</li>
	<li>A {{CSSxRef("&lt;gradient&gt;")}} data type</li>
	<li>A part of the webpage, defined by the {{CSSxRef("element")}} function</li>
	<li>An image, image fragment or solid patch of color, defined by the {{CSSxRef("image()")}} function</li>
	<li>A blending of two or more images defined by the {{CSSxRef("cross-fade")}} function.</li>
	<li>A selection of images chosen based on resolution defined by the {{CSSxRef("image-set")}} function.</li>
</ul>

<h2 id="Description">Description</h2>

<p>CSS can handle the following kinds of images:</p>

<ul>
	<li>Images with <em>intrinsic dimensions</em> (a natural size), like a JPEG, PNG, or other <a href="https://en.wikipedia.org/wiki/Raster_graphics">raster format</a>.</li>
	<li>Images with <em>multiple intrinsic dimensions</em>, existing in multiple versions inside a single file, like some .ico formats. (In this case, the intrinsic dimensions will be those of the image largest in area and the aspect ratio most similar to the containing box.)</li>
	<li>Images with no intrinsic dimensions but with <em>an intrinsic aspect ratio</em> between its width and height, like an SVG or other <a href="https://en.wikipedia.org/wiki/Vector_graphics">vector format</a>.</li>
	<li id="no_intrinsic">Images with <em>neither intrinsic dimensions, nor an intrinsic aspect ratio</em>, like a CSS gradient.</li>
</ul>

<p>CSS determines an object's <em>concrete size</em> using (1) its <em>intrinsic dimensions</em>; (2) its <em>specified size</em>, defined by CSS properties like {{CSSxRef("width")}}, {{CSSxRef("height")}}, or {{CSSxRef("background-size")}}; and (3) its <em>default size</em>, determined by the kind of property the image is used with:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Kind of Object (CSS Property)</th>
			<th scope="col">Default object size</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{CSSxRef("background-image")}}</td>
			<td>The size of the element's background positioning area</td>
		</tr>
		<tr>
			<td>{{CSSxRef("list-style-image")}}</td>
			<td>The size of a <code>1em</code> character</td>
		</tr>
		<tr>
			<td>{{CSSxRef("border-image-source")}}</td>
			<td>The size of the element's border image area</td>
		</tr>
		<tr>
			<td>{{CSSxRef("cursor")}}</td>
			<td>The browser-defined size matching the usual cursor size on the client's system</td>
		</tr>
		<tr>
			<td>{{CSSxRef("mask-image")}}</td>
			<td>?</td>
		</tr>
		<tr>
			<td>{{CSSxRef("shape-outside")}}</td>
			<td>?</td>
		</tr>
		<tr>
			<td>{{CSSxRef("mask-border-source")}}</td>
			<td>?</td>
		</tr>
		<tr>
			<td>{{CSSxRef("symbols")}} for @counter-style</td>
			<td>At risk feature. If supported, the browser-defined size matching the usual cursor size on the client's system</td>
		</tr>
		<tr>
			<td>{{CSSxRef("content")}} for a pseudo-element ({{CSSxRef("::after")}}/{{CSSxRef("::before")}})</td>
			<td>A 300px × 150px rectangle</td>
		</tr>
	</tbody>
</table>

<p>The concrete object size is calculated using the following algorithm:</p>

<ul>
	<li>If the specified size defines <em>both the width and the height</em>, these values are used as the concrete object size.</li>
	<li>If the specified size defines <em>only the width or only the height</em>, the missing value is determined using the intrinsic ratio, if there is any, the intrinsic dimensions if the specified value matches, or the default object size for that missing value.</li>
	<li>If the specified size defines <em>neither the width nor the height</em>, the concrete object size is calculated so that it matches the intrinsic aspect ratio of the image but without exceeding the default object size in any dimension. If the image has no intrinsic aspect ratio, the intrinsic aspect ratio of the object it applies to is used; if this object has none, the missing width or height are taken from the default object size.</li>
</ul>

<div class="note"><strong>Note:</strong> Not all browsers support every type of image on every property. See the <a href="/en-US/docs/Web/CSS/image#Browser_compatibility">browser compatibility section</a> for details.</div>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Browsers do not provide any special information on background images to assistive technology. This is important primarily for screen readers, as a screen reader will not announce its presence and therefore convey nothing to its users. If the image contains information critical to understanding the page's overall purpose, it is better to describe it semantically in the document.</p>

<ul>
	<li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.1_%E2%80%94_Providing_text_alternatives_for_non-text_content">MDN Understanding WCAG, Guideline 1.1 explanations</a></li>
	<li><a href="https://www.w3.org/TR/2016/NOTE-UNDERSTANDING-WCAG20-20161007/text-equiv-all.html">Understanding Success Criterion 1.1.1 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Valid_images">Valid images</h3>

<pre class="brush: css example-good notranslate">url(test.jpg)               /* A &lt;url&gt;, as long as test.jpg is an actual image */
linear-gradient(blue, red)  /* A &lt;gradient&gt; */
element(#realid)            /* A part of the webpage, referenced with the element() function,
                               if "realid" is an existing ID on the page */
image(ltr 'arrow.png#xywh=0,0,16,16', red)
                            /* A section 16x16 section of &lt;url&gt;, starting from the top, left of the original
                               image as long as arrow.png is a supported image, otherwise a solid
                               red swatch. If language is rtl, the image will be horizontally flipped. */
cross-fade(20% url(twenty.png), url(eighty.png))
                            /* cross faded images, with twenty being 20% opaque
                               and eighty being 80% opaque. */
image-set('test.jpg' 1x, 'test-2x.jpg' 2x)
                            /* a selection of images with varying resolutions */</pre>

<h3 id="Invalid_images">Invalid images</h3>

<pre class="brush: css example-bad notranslate">nourl.jpg            /* An image file must be defined using the url() function. */
url(report.pdf)      /* A file pointed to by the url() function must be an image. */
element(#fakeid)     /* An element ID must be an existing ID on the page. */
image(z.jpg#xy=0,0)  /* The spatial fragment must be written in the format of xywh=#,#,#,# */
image-set('cat.jpg' 1x, 'dog.jpg' 1x) /* every image in an image set must have a different resolutions */
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS4 Images", "#typedef-image", "&lt;image&gt;")}}</td>
			<td>{{Spec2("CSS4 Images")}}</td>
			<td>Adds {{CSSxRef("element()")}}, {{CSSxRef("image()")}}, {{CSSxRef("image-set")}}, {{CSSxRef("conic-gradient")}}, {{CSSxRef("repeating-conic-gradient", "repeating-conic-gradient()")}}, and {{CSSxRef("image-resolution")}}.</td>
		</tr>
		<tr>
			<td>{{SpecName("CSS3 Images", "#typedef-image", "&lt;image&gt;")}}</td>
			<td>{{Spec2("CSS3 Images")}}</td>
			<td>Initial definition. Before this, there was no explicitly defined <code>&lt;image&gt;</code> data type. Images could only be defined using the <code>url()</code> functional notation.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.image")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{CSSxRef("&lt;gradient&gt;")}}</li>
	<li>{{CSSxRef("element")}}</li>
	<li>{{CSSxRef("imagefunction", "image()")}}</li>
	<li>{{CSSxRef("image-set")}}</li>
	<li>{{CSSxRef("cross-fade")}}</li>
</ul>
